package es.um.atica.cursoj2ee.backbeans;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.log.Log;
import org.primefaces.event.ScheduleEntryMoveEvent;
import org.primefaces.event.ScheduleEntryResizeEvent;
import org.primefaces.event.SelectEvent;
import org.primefaces.model.DefaultScheduleEvent;
import org.primefaces.model.DefaultScheduleModel;
import org.primefaces.model.ScheduleEvent;
import org.primefaces.model.ScheduleModel;

import es.um.atica.cursoj2ee.model.ElementoAgenda;

@Name("manejadorAgendaBean")
@Scope(ScopeType.CONVERSATION)
public class ManejadorAgendaBean implements Serializable {
	private static final long serialVersionUID = 2408191741678188204L;
	@Logger
	private Log log;

	private ScheduleModel agenda;
	private DefaultScheduleEvent eventoSeleccionado;

	private HashMap<String, ElementoAgenda> agendas;

	private String agendaDestino = "Agenda 1";

	@Create
	public void inicializaBean() {
		agenda = new DefaultScheduleModel();
		agendas = new HashMap<String, ElementoAgenda>();

		SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy HH:mm");

		try {
			DefaultScheduleEvent evento = new DefaultScheduleEvent(
					"Reunin importante", sdf.parse("02/04/2014 10:00"),
					sdf.parse("02/04/2014 15:00"));
			evento.setStyleClass("agenda1");
			ElementoAgenda agenda1 = new ElementoAgenda("Agenda 1");
			agenda1.getEventos().add(evento);
			agenda1.setStyleClass("agenda1");
			agendas.put("Agenda 1", agenda1);
			cambiarAgenda(agenda1);
			ElementoAgenda agenda2 = new ElementoAgenda("Agenda 2");
			agenda2.getEventos().add(
					new DefaultScheduleEvent("Revisin mdica", sdf
							.parse("02/04/2014 13:00"), sdf
							.parse("04/04/2014 10:00"), "agenda2"));
			agenda2.setStyleClass("agenda2");
			agendas.put("Agenda 2", agenda2);
			cambiarAgenda(agenda2);
			ElementoAgenda agenda3 = new ElementoAgenda("Agenda 3");
			agenda3.getEventos().add(
					new DefaultScheduleEvent("Charla pblica", sdf
							.parse("03/04/2014 11:00"), sdf
							.parse("04/04/2014 11:00"), "agenda3"));
			agenda3.setStyleClass("agenda3");
			agendas.put("Agenda 3", agenda3);
			cambiarAgenda(agenda3);
		} catch (Exception e) {
			log.error("error: ", e);
		}
	}

	public void cambiarAgenda(ElementoAgenda agendaSeleccionada) {
		if (agendaSeleccionada.isActiva()) {
			for (DefaultScheduleEvent dse : agendaSeleccionada.getEventos()) {
				agenda.addEvent(dse);
			}
		} else {
			for (DefaultScheduleEvent dse : agendaSeleccionada.getEventos()) {
				agenda.deleteEvent(dse);
			}
		}
		// agendaSeleccionada.setActiva(activar);
		// agenda = new DefaultScheduleModel();
		// for (ElementoAgenda agendaSel : agendas) {
		// if (agendaSel.isActiva()) {
		// for (DefaultScheduleEvent ev : agendaSel.getEventos()) {
		// agenda.addEvent(ev);
		// }
		// }
		// }
	}

	public void crearEvento() {
		ElementoAgenda ea = agendas.get(agendaDestino);
		this.eventoSeleccionado.setStyleClass(ea.getStyleClass());
		ea.getEventos().add(this.eventoSeleccionado);
		agenda.addEvent(this.eventoSeleccionado);
	}

	public void onEventSelect(SelectEvent selectEvent) {
		eventoSeleccionado = (DefaultScheduleEvent) selectEvent.getObject();
	}

	public void onDateSelect(SelectEvent selectEvent) {
		eventoSeleccionado = new DefaultScheduleEvent("",
				(Date) selectEvent.getObject(), (Date) selectEvent.getObject());
	}

	public void onEventMove(ScheduleEntryMoveEvent event) {
		FacesMessage message = new FacesMessage(FacesMessage.SEVERITY_INFO,
				"Evento movido", "");

		addMessage(message);
	}

	public void onEventResize(ScheduleEntryResizeEvent event) {
		FacesMessage message = new FacesMessage(FacesMessage.SEVERITY_INFO,
				"Evento redimensionado", "");

		addMessage(message);
	}

	private void addMessage(FacesMessage message) {
		FacesContext.getCurrentInstance().addMessage(null, message);
	}

	public ScheduleModel getAgenda() {
		return agenda;
	}

	public void setAgenda(ScheduleModel agenda) {
		this.agenda = agenda;
	}

	public ScheduleEvent getEventoSeleccionado() {
		return eventoSeleccionado;
	}

	public void setEventoSeleccionado(DefaultScheduleEvent eventoSeleccionado) {
		this.eventoSeleccionado = eventoSeleccionado;
	}

	public String getAgendaDestino() {
		return agendaDestino;
	}

	public void setAgendaDestino(String agendaDestino) {
		this.agendaDestino = agendaDestino;
	}

	public List<ElementoAgenda> listarAgendas() {
		ArrayList<ElementoAgenda> listado = new ArrayList<ElementoAgenda>();
		for (String key : agendas.keySet()) {
			listado.add(agendas.get(key));
		}
		return listado;
	}

	public HashMap<String, ElementoAgenda> getAgendas() {
		return agendas;
	}

	public void setAgendas(HashMap<String, ElementoAgenda> agendas) {
		this.agendas = agendas;
	}

}
