package es.um.atica.cursoj2ee.backbeans;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.log.Log;
import org.primefaces.model.chart.Axis;
import org.primefaces.model.chart.AxisType;
import org.primefaces.model.chart.BarChartModel;
import org.primefaces.model.chart.BarChartSeries;
import org.primefaces.model.chart.CartesianChartModel;
import org.primefaces.model.chart.CategoryAxis;
import org.primefaces.model.chart.ChartSeries;
import org.primefaces.model.chart.LineChartModel;
import org.primefaces.model.chart.LineChartSeries;

import es.um.atica.cursoj2ee.daos.interfaces.ServicioPersistencia;
import es.um.atica.cursoj2ee.dtos.EstProyectos;
import es.um.atica.cursoj2ee.model.ElementoGrafica;

@Name("manejadorInput")
@Scope(ScopeType.CONVERSATION)
public class ManejadorInputBean {

	@Logger
	private Log log;

	@In(create = true)
	private ServicioPersistencia servicioPersistencia;

	private List<EstProyectos> proyectos;

	private List<EstProyectos> proyectosSeleccionados;

	private String configuracionEditor = "";

	private List<String> propiedadesEditorSeleccionadas;

	private List<String> propiedadesEditor;

	private String mascara;
	private List<String> anios;
	private HashMap<String, ElementoGrafica> alumnos;
	private HashMap<String, ElementoGrafica> profesores;

	private BarChartModel chartBarras;
	private LineChartModel chartLineas;

	private boolean puedeGenerarGrafica;

	private String valorEditor;

	private int valorMaximoGrafica = 0;

	private String formatoBarra = "<span style=\"display:none;\">%s</span><span>%s</span>";

	private CartesianChartModel diagramaCombiado1;

	private String radioSeleccionado = "1";
	private int valoracion = 0;
	private int medicion = 0;

	public String valoracionSeleccionada() {
		switch (radioSeleccionado) {
		case "1":
			return "Valoracion: " + valoracion;
		case "2":
			return "Medicin: " + medicion;

		}
		return "Sin valorar an";
	}

	public int getMedicion() {
		return medicion;
	}

	public void setMedicion(int medicion) {
		this.medicion = medicion;
	}

	public int getValoracion() {
		return valoracion;
	}

	public void setValoracion(int valoracion) {
		this.valoracion = valoracion;
	}

	public String getRadioSeleccionado() {
		return radioSeleccionado;
	}

	public void setRadioSeleccionado(String radioSeleccionado) {
		this.radioSeleccionado = radioSeleccionado;
	}

	public String getMascara() {
		return mascara;
	}

	public void setMascara(String mascara) {
		this.mascara = mascara;
	}

	public List<String> getPropiedadesEditor() {
		return propiedadesEditor;
	}

	public void setPropiedadesEditor(List<String> propiedadesEditor) {
		this.propiedadesEditor = propiedadesEditor;
	}

	// TODO: Metodo para el test de carga
	public void testCarga() {
		log.debug("TestCarga");
		int[] lista = new int[1000];
		int aux;
		for (int i = 0; i < 1000; i++) {
			lista[i] = i;
		}
		for (int i = 0; i < lista.length - 1; i++)
			for (int j = 0; j < lista.length - i - 1; j++)
				if (lista[j + 1] > lista[j]) {
					aux = lista[j + 1];
					lista[j + 1] = lista[j];
					lista[j] = aux;
				}
	}

	@Create
	public void inicializaBean() {
		propiedadesEditor = new ArrayList<String>();
		propiedadesEditorSeleccionadas = new ArrayList<String>();
		propiedadesEditor.add("Decoradores texto");
		propiedadesEditor.add("Estilos fuente");
		propiedadesEditor.add("Indentacin");
		propiedadesEditor.add("Herramientas de edicin");
		propiedadesEditor.add("Herramientas genricas");
		anios = new ArrayList<String>();
		anios.add("2012");
		anios.add("2013");
		anios.add("2014");
		alumnos = new HashMap<String, ElementoGrafica>();
		profesores = new HashMap<String, ElementoGrafica>();
		for (String anio : anios) {
			alumnos.put(anio, new ElementoGrafica(0));
			profesores.put(anio, new ElementoGrafica(0));
		}
	}

	public void generarDiagramas() {
		valorMaximoGrafica = 0;
		diagramaCombiado1 = new BarChartModel();
		BarChartSeries chartBarrasC = new BarChartSeries();
		LineChartSeries chartLineaC = new LineChartSeries();

		this.puedeGenerarGrafica = true;
		chartBarras = new BarChartModel();
		chartLineas = new LineChartModel();

		ChartSeries alumnosCS = new ChartSeries();
		alumnosCS.setLabel("Alumnos");
		chartBarrasC.setLabel("Alumnos");
		ChartSeries profesoresCS = new ChartSeries();
		profesoresCS.setLabel("Profesores");
		chartLineaC.setLabel("Profesores");

		for (String key : anios) {
			if (valorMaximoGrafica < alumnos.get(key).getValor()) {
				valorMaximoGrafica = alumnos.get(key).getValor();
			}
			alumnosCS.set(key, alumnos.get(key).getValor());
			chartBarrasC.set(key, alumnos.get(key).getValor());
		}

		for (String key : anios) {
			if (valorMaximoGrafica < profesores.get(key).getValor()) {
				valorMaximoGrafica = profesores.get(key).getValor();
			}
			profesoresCS.set(key, profesores.get(key).getValor());
			chartLineaC.set(key, profesores.get(key).getValor());
		}
		valorMaximoGrafica += 2;
		chartLineas.addSeries(alumnosCS);
		chartLineas.addSeries(profesoresCS);
		chartBarras.addSeries(alumnosCS);
		chartBarras.addSeries(profesoresCS);

		diagramaCombiado1.addSeries(chartBarrasC);
		diagramaCombiado1.addSeries(chartLineaC);

		chartLineas.setTitle("Linear Chart");
		chartLineas.setLegendPosition("e");
		Axis yAxis = chartLineas.getAxis(AxisType.Y);
		yAxis.setMin(0);
		yAxis.setMax(valorMaximoGrafica);
		chartLineas.getAxes().put(AxisType.X, new CategoryAxis("Aos"));
		chartLineas.setAnimate(true);

	}

	public List<String> getPropiedadesEditorSeleccionadas() {
		return propiedadesEditorSeleccionadas;

	}

	public void actualizaEditor() {
		configuracionEditor = "";
		for (String s : propiedadesEditorSeleccionadas) {
			switch (s) {
			case "Decoradores texto":
				configuracionEditor += " bold italic underline strikethrough subscript superscript";
				break;
			case "Estilos fuente":
				configuracionEditor += " font size style color highlight";
				break;
			case "Indentacin":
				configuracionEditor += " bullets numbering alignleft center alignright justify outdent indent";
				break;
			case "Herramientas de edicin":
				configuracionEditor += " rule image link unlink cut copy paste pastetext";
				break;
			case "Herramientas genricas":
				configuracionEditor += " print source";
				break;
			}
		}
	}

	public void setPropiedadesEditorSeleccionadas(
			List<String> propiedadesEditorSeleccionados) {
		this.propiedadesEditorSeleccionadas = propiedadesEditorSeleccionados;
		actualizaEditor();
	}

	public String getConfiguracionEditor() {
		return configuracionEditor;
	}

	public void setConfiguracionEditor(String configuracionEditor) {
		this.configuracionEditor = configuracionEditor;
	}

	public List<EstProyectos> filtrarProyectos(String prefijo) {
		List<EstProyectos> lista = new ArrayList<EstProyectos>();
		for (EstProyectos proy : getProyectos()) {
			if (proy.getId().toLowerCase().startsWith(prefijo.toLowerCase())) {
				lista.add(proy);
			}
		}
		return lista;
	}

	public List<EstProyectos> getProyectosSeleccionados() {
		return proyectosSeleccionados;
	}

	public void setProyectosSeleccionados(
			List<EstProyectos> proyectosSeleccionados) {
		this.proyectosSeleccionados = proyectosSeleccionados;
	}

	public List<EstProyectos> getProyectos() {
		if (proyectos == null || proyectos.isEmpty()) {
			proyectos = servicioPersistencia.obtenerProyectos();
		}
		return proyectos;
	}

	public void setProyectos(List<EstProyectos> proyectos) {
		this.proyectos = proyectos;
	}

	public ServicioPersistencia getServicioPersistencia() {
		return servicioPersistencia;
	}

	public void setServicioPersistencia(
			ServicioPersistencia servicioPersistencia) {
		this.servicioPersistencia = servicioPersistencia;
	}

	public BarChartModel getChartBarras() {
		return chartBarras;
	}

	public void setChartBarras(BarChartModel chartBarras) {
		this.chartBarras = chartBarras;
	}

	public LineChartModel getChartLineas() {
		return chartLineas;
	}

	public void setChartLineas(LineChartModel chartLineas) {
		this.chartLineas = chartLineas;
	}

	public String getValorEditor() {
		return valorEditor;
	}

	public void setValorEditor(String valorEditor) {
		this.valorEditor = valorEditor;
	}

	public HashMap<String, ElementoGrafica> getAlumnos() {
		return alumnos;
	}

	public void setAlumnos(HashMap<String, ElementoGrafica> alumnos) {
		this.alumnos = alumnos;
	}

	public HashMap<String, ElementoGrafica> getProfesores() {
		return profesores;
	}

	public void setProfesores(HashMap<String, ElementoGrafica> profesores) {
		this.profesores = profesores;
	}

	public boolean isPuedeGenerarGrafica() {
		return puedeGenerarGrafica;
	}

	public void setPuedeGenerarGrafica(boolean puedeGenerarGrafica) {
		this.puedeGenerarGrafica = puedeGenerarGrafica;
	}

	public int getValorMaximoGrafica() {
		return valorMaximoGrafica;
	}

	public void setValorMaximoGrafica(int valorMaximoGrafica) {
		this.valorMaximoGrafica = valorMaximoGrafica;
	}

	public String getFormatoBarra() {
		return formatoBarra;
	}

	public void setFormatoBarra(String formatoBarra) {
		this.formatoBarra = formatoBarra;
	}

	public CartesianChartModel getDiagramaCombiado1() {
		return diagramaCombiado1;
	}

	public void setDiagramaCombiado1(CartesianChartModel diagramaCombiado1) {
		this.diagramaCombiado1 = diagramaCombiado1;
	}

}
