package es.um.atica.cursoj2ee.das.impl;

import java.util.Arrays;
import java.util.Map;

import javax.ejb.Local;
import javax.ejb.Stateless;

import org.jboss.seam.annotations.Name;

import es.um.atica.commons.utils.UtilString;
import es.um.atica.cursoj2ee.das.interfaces.AnuncioDataAccessService;
import es.um.atica.cursoj2ee.dtos.Anuncio;
import es.um.atica.jpa.das.DataAccessServiceImpl;
import es.um.atica.jpa.das.ResultQuery;

@Name("anuncioDAS")
@Local(AnuncioDataAccessService.class)
@Stateless
public class AnuncioDataAccessServiceBean extends
		DataAccessServiceImpl<Anuncio> implements AnuncioDataAccessService {

	private static final String[] RESTRICTIONS_ANUNCIO = {

			UtilString.cmpNumberTextFilterEjbql("entity.id", ":anuncioId"),
			UtilString.cmpTextFilterEjbql("entity.nombre", ":anuncioNombre"),
			UtilString.cmpTextFilterEjbql("entity.descripcion",
					":anuncioDescripcion"),
			UtilString.cmpDateTextFilterEjbql("entity.fechaPublicacion",
					":anuncioFechaPublicacion"),

	};

	public ResultQuery<Anuncio> resultsByQueryWithDinamicFilter(
			Map<String, Object> parameters, int firstResult, int resultLimit,
			String sortField, String sortOrder) {
		return super.resultsByEntityQueryWithDinamicFilter(getConcreteQuery(),
				Arrays.asList(RESTRICTIONS_ANUNCIO), parameters, firstResult,
				resultLimit, sortField, sortOrder, null, null);
	}

	@Override
	public Long countTotalRecord(Map<String, Object> parameters) {
		return super.countTotalRecordByEntityQuery(super.getConcreteCountQuery(),
				Arrays.asList(RESTRICTIONS_ANUNCIO), parameters, "and", null);
	}

}
