package es.um.atica.cursoj2ee.das.impl;

import java.util.List;
import java.util.Map;

import javax.ejb.Local;
import javax.ejb.Stateless;
import javax.persistence.Query;

import org.jboss.seam.annotations.Name;

import es.um.atica.commons.utils.UtilString;
import es.um.atica.cursoj2ee.das.interfaces.ComentarioDataAccessService;
import es.um.atica.cursoj2ee.dtos.Comentario;
import es.um.atica.jpa.das.DataAccessServiceImpl;

@Name("comentarioDAS")
@Local(ComentarioDataAccessService.class)
@Stateless
public class ComentarioDataAccessServiceBean extends DataAccessServiceImpl<Comentario> implements
		ComentarioDataAccessService {
	
	public int getMaxNumeroComentarioOfAnuncio(Long anuncioId) {
		Query jpaQuery = this.getEntityManager().createNamedQuery("numeroComentarioAnuncio");
		jpaQuery.setParameter("anuncioId", anuncioId);
		Number result = (Number) jpaQuery.getSingleResult();
		return result.intValue();
	}
	
	public List<Comentario> findByQuery(Map<String, Object> parameters, int firstResult, int resultLimit) {
		return super.findByNamedQuery("comentariosAnuncio", parameters, firstResult, resultLimit, null);
	}
	
	public Long countTotalRecord(Map<String, Object> parameters) {
		return countTotalRecordByNamedQuery("totalComentariosAnuncio", parameters, null);
	}
	
}
