package es.um.atica.cursoj2ee.dtos;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;


@Entity
@NamedQueries({
		@NamedQuery(name = "comentariosAnuncio", query = "select com from Comentario com where com.anuncio.id = :anuncioId"),
		@NamedQuery(name = "totalComentariosAnuncio", query = "select count(com) from Comentario com where com.anuncio.id = :anuncioId"),
		@NamedQuery(name = "numeroComentarioAnuncio", query = "select max(com.numero) + 1 from Comentario com where com.anuncio.id = :anuncioId")
})
@SequenceGenerator(name = "comentarioID", sequenceName = "SEC_COMENTARIOS")
public class Comentario implements Serializable {
	
	private static final long serialVersionUID = 3626082753226792607L;
	
	@Id
	@GeneratedValue(generator = "comentarioID",strategy=GenerationType.AUTO)
	private long id;
	@Column(nullable = false, length = 100)
	private String usuario;
	@Column(nullable = true, length = 500)
	private String texto;
	@Temporal(TemporalType.DATE)
	@Column(nullable = false)
	private Date fecha;
	@Column(nullable = false)
	private long numero;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ANUNCIO", nullable = false)
	@NotNull
	private Anuncio anuncio;

	public Comentario() {
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getUsuario() {
		return usuario;
	}

	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	public String getTexto() {
		return texto;
	}

	public void setTexto(String texto) {
		this.texto = texto;
	}

	public Date getFecha() {
		return fecha;
	}

	public void setFecha(Date fecha) {
		this.fecha = fecha;
	}

	public long getNumero() {
		return numero;
	}

	public void setNumero(long numero) {
		this.numero = numero;
	}

	public Anuncio getAnuncio() {
		return anuncio;
	}

	public void setAnuncio(Anuncio anuncio) {
		this.anuncio = anuncio;
	}

}
