package es.um.atica.cursoj2ee.lazy;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.jboss.seam.Component;
import org.primefaces.model.LazyDataModel;
import org.primefaces.model.SortOrder;

import es.um.atica.cursoj2ee.dtos.Anuncio;
import es.um.atica.cursoj2ee.services.impl.ServicioPersistenciaAnuncios;
import es.um.atica.jpa.das.ResultQuery;

public class LazyAnuncioDataModel extends LazyDataModel<Anuncio> {

	private static final long serialVersionUID = -7128353552033320971L;

	private List<Anuncio> anuncios;
	private Map<String, Object> parametros;
	private ServicioPersistenciaAnuncios servicioAnuncios;

	public LazyAnuncioDataModel() {
		anuncios = new ArrayList<Anuncio>();
	}

	public Map<String, Object> getParametros() {
		return parametros;
	}

	public void setParametros(Map<String, Object> parametros) {
		this.parametros = parametros;
	}

	@Override
	public Object getRowKey(Anuncio anuncio) {
		return anuncio.getId();
	}

	@Override
	public List<Anuncio> load(int first, int pageSize, String sortField,
			SortOrder sortOrder, Map<String, Object> filters) {

		ResultQuery<Anuncio> resultQuery = getServicioAnuncios()
				.obtenerListadoAnuncios(parametros, first, pageSize, sortField,
						sortOrder.name());
		anuncios = resultQuery.getResultList();
		
		setRowCount(getServicioAnuncios().obtenerTotalAnuncios(parametros).intValue());
		return anuncios;
	}

	@Override
	public Anuncio getRowData(String rowKey) {
		for (Anuncio an : anuncios) {
			if (Long.toString(an.getId()).equals(rowKey)) {
				return an;
			}
		}
		return null;
	}

	private ServicioPersistenciaAnuncios getServicioAnuncios() {
		if (servicioAnuncios == null) {
			this.servicioAnuncios = (ServicioPersistenciaAnuncios) Component
					.getInstance("servicioPersistenciaAnuncios");
		}
		return this.servicioAnuncios;
	}

}
