package es.um.atica.cursoj2ee.lazy;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.jboss.seam.Component;
import org.primefaces.model.LazyDataModel;
import org.primefaces.model.SortOrder;

import es.um.atica.cursoj2ee.dtos.Comentario;
import es.um.atica.cursoj2ee.services.impl.ServicioPersistenciaAnuncios;

public class LazyComentarioDataModel extends LazyDataModel<Comentario> {

	private static final long serialVersionUID = -7128353552033320971L;

	private List<Comentario> comentarios;
	private Map<String, Object> parametros;
	private ServicioPersistenciaAnuncios servicioAnuncios;
	
	public LazyComentarioDataModel() {
		comentarios = new ArrayList<Comentario>();
	}

	public Map<String, Object> getParametros() {
		return parametros;
	}

	public void setParametros(Map<String, Object> parametros) {
		this.parametros = parametros;
	}
	
	@Override
	public Object getRowKey(Comentario comentario) {
		return comentario.getId();
	}

	@Override
	public List<Comentario> load(int first, int pageSize, String sortField, SortOrder sortOrder,
								Map<String, Object> filters) {
		comentarios = getServicioAnuncios().obtenerListadoComentarios(parametros, first, pageSize);
		setRowCount(comentarios.size());
		return comentarios;
	}

	@Override
	public Comentario getRowData(String rowKey) {
		for (Comentario com : comentarios) {
			if (Long.toString(com.getId()).equals(rowKey)) {
				return com;
			}
		}

		return null;
	}

	private ServicioPersistenciaAnuncios getServicioAnuncios() {
		if (servicioAnuncios == null) {
			this.servicioAnuncios = (ServicioPersistenciaAnuncios) Component.getInstance("servicioPersistenciaAnuncios");
		}
		return this.servicioAnuncios;
	}
	
}
