package es.um.atica.cursoj2ee.security.authentication;

import static org.jboss.seam.annotations.Install.FRAMEWORK;

import org.jboss.seam.annotations.Install;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.intercept.BypassInterceptors;
import org.jboss.seam.log.Log;
import org.jboss.seam.log.Logging;

import es.um.atica.seam.components.FundeWebManagerBean;

@Name("authenticator")
@Install(precedence = FRAMEWORK)
@BypassInterceptors
public class AuthenticatorAction extends FundeWebManagerBean {

	private static final Log LOG = Logging.getLog(AuthenticatorAction.class);
	
	public boolean authenticate() {
		return isAuthenticated() && hasApplicationSpecificPermission();
	}

	protected boolean isAuthenticated() {
		return getAuthenticationManagerBean().getAuthenticationMethod().authenticate();
	}

	/**
	 * Metodo para comprobar permisos especificos del usuario para acceder a la aplicacion
	 * 
	 * @return boolean - indica si el usuario tiene permisos de acceso a la aplicacion
	 */
	protected boolean hasApplicationSpecificPermission() {
		return true;
	}

	protected AuthenticationManagerBean getAuthenticationManagerBean() {
		return AuthenticationManagerBean.instance();
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see es.um.atica.util.FundeWebManagerBean#getLog()
	 */
	@Override
	protected Log getLog() {
		return LOG;
	}

}
